package aud.exam.prep.array;

import aud.exam.prep.Pair;

import java.util.Comparator;
import java.util.Iterator;

public class RecursiveFullyUsedArrayProcessor<T> extends FullyUsedArrayProcessor<T> {

    @Override
    public boolean find(FullyUsedArray<T> array, T t) {
        return false;
    }

    @Override
    public boolean findBinary(FullyUsedArray<T> array, T t, Comparator<T> cmp) {
        return false;
    }

    @Override
    public boolean override(FullyUsedArray<T> array, T from, T to) {
        return false;
    }

    @Override
    public boolean overrideAll(FullyUsedArray<T> array, T from, T to) {
        return false;
    }

    @Override
    public void insertInOrder(FullyUsedArray<T> array, T t, Comparator<T> cmp) {

    }

    @Override
    public boolean remove(FullyUsedArray<T> array, T t) {
        return false;
    }

    @Override
    public boolean removeAll(FullyUsedArray<T> array, T t) {
        return false;
    }

    @Override
    public boolean isAscending(FullyUsedArray<T> array, Comparator<T> cmp) {
        return false;
    }

    @Override
    public T max(FullyUsedArray<T> array, Comparator<T> cmp) {
        return null;
    }

    @Override
    public T secondMax(FullyUsedArray<T> array, Comparator<T> cmp) {
        return null;
    }

    @Override
    public boolean isItemWiseLessOrEqual(FullyUsedArray<T> a, FullyUsedArray<T> b, Comparator<T> cmp) {
        return false;
    }

    @Override
    public boolean isItemWiseLess(FullyUsedArray<T> a, FullyUsedArray<T> b, Comparator<T> cmp) {
        return false;
    }

    @Override
    public boolean isLexSmaller(FullyUsedArray<T> a, FullyUsedArray<T> b, Comparator<T> cmp) {
        return false;
    }

    @Override
    public void exchangePairs(FullyUsedArray<T> array) {

    }

    @Override
    public void rotateTriples(FullyUsedArray<T> array) {

    }

    @Override
    public void removeEverySecond(FullyUsedArray<T> array) {

    }

    @Override
    public void doubleAllKeys(FullyUsedArray<T> array) {

    }

    @Override
    public FullyUsedArray<T> rotateRight(FullyUsedArray<T> array) {
        return null;
    }

    @Override
    public FullyUsedArray<T> rotateLeft(FullyUsedArray<T> array) {
        return null;
    }

    @Override
    public void removeDuplicates(FullyUsedArray<T> array) {

    }

    @Override
    public FullyUsedArray<T> invert(FullyUsedArray<T> array) {
        return null;
    }

    @Override
    public FullyUsedArray<T> clone(FullyUsedArray<T> array) {
        return null;
    }

    @Override
    public FullyUsedArray<T> alternate(FullyUsedArray<T> a, FullyUsedArray<T> b) {
        return null;
    }

    @Override
    public FullyUsedArray<T> merge(FullyUsedArray<T> a, FullyUsedArray<T> b, Comparator<T> cmp) {
        return null;
    }

    @Override
    public Pair<FullyUsedArray<T>, FullyUsedArray<T>> divideAlternating(FullyUsedArray<T> array) {
        return null;
    }

    @Override
    public Pair<FullyUsedArray<T>, FullyUsedArray<T>> divideAlternatingByRuns(FullyUsedArray<T> array, Comparator<T> cmp) {
        return null;
    }

    @Override
    public Pair<FullyUsedArray<T>, FullyUsedArray<T>> divideByPivot(FullyUsedArray<T> array, T pivot, Comparator<T> cmp) {
        return null;
    }

    @Override
    public FullyUsedArray<T> create(Iterable<T> iterable) {
        var size = countElement(iterable.iterator());
        var array = new FullyUsedArray<T>();

        array.theArray = Arrays.newArray(size);
        copyElements(array.theArray, iterable.iterator(), 0);

        return array;
    }

    private void copyElements(T[] array, Iterator<T> iter, int index) {
        if (index < array.length) {
            array[index] = iter.next();
            copyElements(array, iter, index+1);
        }
    }

    private int countElement(Iterator<T> iter) {
        if (iter.hasNext()) {
            iter.next();
            return 1 + countElement(iter);
        }
        return 0;
    }
}
